#pragma once
#include "Object.h"
#include "Array.h"
#include "Field.h"
#include <exception>
#include <format>
#include <string>
namespace rei::json {

	class ParsingError : public std::exception {
		public:
		ParsingError(const std::string& reason, int line, int column) { 
			str = std::format("{}:{}: {}", line, column, reason);
		}

		const char * what() const noexcept override {
			return str.c_str();
		}

		private:
		std::string str;
	};

	class FieldValue parse(const std::string& jsonStr);

	std::string toString(JsonObject& object);
	std::string toString(JsonArray& object);
}
